# PA165 Team Delta

- **Name:** Winery Management System

- **Developers:**

    - Laura Ondušková @xondusk
    - Martin Hesko @xhesko
    - Martin Pernica @xpernic1
    - Martin Kyjac @xkyjac
    - Vojtěch Peschel @xpesche1

##### Assigment:

Create an information system that will allow a person to manage its own winery in a better way.  The main user role can manage the yearly wine harvest, annotating the quality, quantity of different types of grapes. Then he will manage the wines that can be produced depending on the type of grapes available and other ingredients. The user can also manage the list of wine bottles sold and stocked and available to buyers. Buyers can consult the system to buy quantities of wine bottles, also leaving feedback about the quality of the wine they have bought.

#### Use Case Diagram

![Use Case Diagram](UseCaseDiagram.png)

#### DTO Class Diagram
![Class Diagram](dtodiagram.png)

### How to run

#### Locally
To run application, go to `./winery` folder. Then use `mvn clean install` to build project. Then go to into module you want to run use and `mvn spring-boot:run` to run.

#### In a container
1. Run `mvn clean install` to build all the target images
2. Run `podman-compose build` to build images for all services
3. Run `podman-compose up -d` to run all the services (`docker-compose` works as well)
4. When you're done run `podman-compose down` to shut down all the containers.

### Monitoring access
[Prometheus - localhost:9090](http://localhost:9090)
[Grafana - localhost:3000](http://localhost:3000) - username/pw is `admin` for the login

### Authentication
For authentication, oidc.muni.cz is used. Firstly, you need to generate bearer token that will be attached to security header of the reqest. Bearer token is generated in user-management module on [tihs URL](http://localhost:8080/login). After successful login, you will be redirrected to page where your bearer token will be displayed. Scopes are MANAGER(test_1) and BUYER(test_2)

### Locust
To run locust, you need to install python3 and then install locust with `pip3 install locust` command. After installation, go to directory `/locust` and run command `locust`. Before you run locust, you need to add bearer token with MANAGER scope to `bearer.txt` file to be able to access endpoints. How to get bearer token was described in previous paragraph. After that, locust will run on [localhost:8089](http://localhost:8089). As Host, you can use any URL because all URLs are rewritten directly inside tasks. Tasks describe creating grape and then creating harvest using previously created grape.

The scenario:\
As a winery owner, you need to create a new harvest for the upcoming season. The first step is to create a new type of grape that will be used for the harvest. You start by creating a new grape variety in your system, specifying its details.
Once you have created the new grape variety, you can start planning the harvest. You create a new harvest in your system and select the grape variety you just created as the type of grape that will be harvested. You also specify the additional information such as the location.
With the grape and harvest both created in your system, you can now start planning the rest of the winemaking process.
After the process is completed, wine is aged and then is stored in bottles.




### Swagger links to services
To access our services refer to the list below:
* [grape-management - localhost:8081](http://localhost:8081/swagger-ui/index.html)
* [wine-production - localhost:8082](http://localhost:8082/swagger-ui/index.html)
* [store-wine - localhost:8083](http://localhost:8083/swagger-ui/index.html)
* [sell-wine - localhost:8084](http://localhost:8084/swagger-ui/index.html)
* [user-management - localhost:8080](http://localhost:8080/swagger-ui/index.html)
