package org.delta.dto.entities.bottle;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.enums.WineType;

public class AddBottleDTO extends BottleBaseDTO {

    private String name;
    private WineType wineType;

    @Schema(
            name = "name",
            example = "Chardonnay",
            description = "Name of the wine",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Schema(
            name = "type",
            example = "WHITE",
            description = "Type of wine",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public WineType getWineType() {
        return wineType;
    }

    public void setWineType(WineType wineType) {
        this.wineType = wineType;
    }
}