package org.delta.dto.entities.bottle;

import io.swagger.v3.oas.annotations.media.Schema;

import java.math.BigDecimal;

public class BottleBaseDTO {

    protected BigDecimal price;
    protected BigDecimal volume;
    protected int year;
    protected String origin;
    protected int amount;

    @Schema(
            name = "price",
            example = "1.75",
            description = "price of the bottle",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    @Schema(
            name = "volume",
            example = "0.75",
            description = "volume of the bottle in litres",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public BigDecimal getVolume() {
        return volume;
    }

    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }

    @Schema(
            name = "year",
            example = "2022",
            description = "year when the wine in the bottle was harvested",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    @Schema(
            name = "origin",
            example = "Slovakia",
            description = "Country in which the wine was produced",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getOrigin() {
        return origin;
    }

    public void setOrigin(String origin) {
        this.origin = origin;
    }

    @Schema(
            name = "amount",
            example = "7",
            description = "The amount of bottles stored in warehouse",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public int getAmount() {
        return amount;
    }

    public void setAmount(int amount) {
        this.amount = amount;
    }
}
