package org.delta.dto.entities.bottle;

import com.google.gson.Gson;
import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.enums.WineType;

public class BottleDTO extends BottleBaseDTO {

    private long bottleID;
    private String name;
    private WineType wineType;


    public long getBottleID() {
        return bottleID;
    }

    public void setBottleID(long bottleID) {
        this.bottleID = bottleID;
    }


    @Schema(
            name = "name",
            example = "Chardonnay",
            description = "Name of the wine",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    @Schema(
            name = "type",
            example = "WHITE",
            description = "Type of wine",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public WineType getWineType() {
        return wineType;
    }

    public void setWineType(WineType wineType) {
        this.wineType = wineType;
    }


    @Override
    public boolean equals(Object o) {
        if (o == this) {
            return true;
        }

        if (!(o instanceof BottleDTO)) {
            return false;
        }

        BottleDTO user = (BottleDTO) o;

        return user.getBottleID() == this.bottleID;
    }

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}