package org.delta.dto.entities.container;

import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.v3.oas.annotations.media.Schema;

import java.math.BigDecimal;

public class ContainerBaseDTO {
    protected BigDecimal capacity;
    protected boolean isEmpty;

    @Schema(
            name = "capacity",
            example = "400",
            description = "Capacity of the container in liters",
            requiredMode = Schema.RequiredMode.REQUIRED
    )

    public BigDecimal getCapacity() {
        return capacity;
    }

    public void setCapacity(BigDecimal capacity) {
        this.capacity = capacity;
    }


    @Schema(
            name = "isEmpty",
            example = "true",
            description = "Records full containers",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public boolean getIsEmpty() { return isEmpty; }

    public void setIsEmpty(boolean empty) {
        isEmpty = empty;
    }


    @JsonIgnore
    public boolean getEmpty() {
        return isEmpty;
    }

    @JsonIgnore
    public void setEmpty(boolean empty) {
        isEmpty = empty;
    }
}
