package org.delta.dto.entities.harvest;

import com.google.gson.Gson;
import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.entities.grape.GrapeDTO;

import java.math.BigDecimal;

public class HarvestBaseDTO {
    protected GrapeDTO grape;
    protected BigDecimal volume;
    protected BigDecimal price;
    protected int year;

    @Schema(
            name = "grape",
            subTypes = GrapeDTO.class,
            description = "grape name of the juice",
            requiredMode = Schema.RequiredMode.REQUIRED
    )

    public GrapeDTO getGrape() {
        return grape;
    }
    public void setGrape(GrapeDTO grape) {
        this.grape = grape;
    }


    @Schema(
            name = "volume",
            example = "500",
            description = "volume of grape juice",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public BigDecimal getVolume() {
        return volume;
    }
    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }

    @Schema(
            name = "year",
            example = "1987",
            description = "year of harvest",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public int getYear() {
        return year;
    }
    public void setYear(int year) {
        this.year = year;
    }


    @Override
    public String toString() {
        return new Gson().toJson(this);
    }


    @Schema(
            name = "price",
            example = "300",
            description = "price of grape juice",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }
}
