package org.delta.dto.entities.order;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.entities.bottle.BottleDTO;

import java.util.Set;

public class OrderDTO extends OrderBaseDTO {
    private Set<BottleDTO> bottles;

    private boolean completed;

    private String feedback;

    @Schema(
            name = "bottles",
            example = "",
            description = "Bottles in the order",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public Set<BottleDTO> getBottles() {
        return bottles;
    }

    public void setBottles(Set<BottleDTO> bottles) {
        this.bottles = bottles;
    }


    @Schema(
            name = "completed",
            example = "true",
            description = "Information about whether the order is complete or not",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public boolean isCompleted() {
        return completed;
    }

    public void setCompleted(boolean completed) {
        this.completed = completed;
    }

    @Schema(
            name = "feedback",
            example = "I loved my wine!",
            description = "Feedback on a completed order",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public String getFeedback() {
        return feedback;
    }

    public void setFeedback(String feedback) {
        this.feedback = feedback;
    }
}
