package org.delta.dto.entities.order;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.entities.bottle.BottleListEntityDTO;

import java.util.ArrayList;

public class OrderListEntityDTO extends OrderBaseDTO{

    private ArrayList<BottleListEntityDTO> bottles;

    private boolean completed;

    private String feedback;

    @Schema(
            name = "bottles",
            example = "",
            description = "Bottles in the order",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public ArrayList<BottleListEntityDTO> getBottles() {
        return bottles;
    }

    public void setBottles(ArrayList<BottleListEntityDTO> bottles) {
        this.bottles = bottles;
    }

    @Schema(
            name = "completed",
            example = "true",
            description = "Information about whether the order is complete or not",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public boolean isCompleted() {
        return completed;
    }

    public void setCompleted(boolean completed) {
        this.completed = completed;
    }

    @Schema(
            name = "feedback",
            example = "I loved my wine!",
            description = "Feedback on a completed order",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public String getFeedback() {
        return feedback;
    }

    public void setFeedback(String feedback) {
        this.feedback = feedback;
    }
}
