package org.delta.dto.entities.user;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.enums.UserRole;

public class AddUserDTO extends UserBaseDTO {
    private UserRole role;
    private String password;
    private String email;


    @Schema(
            name = "role",
            example = "MANAGER",
            description = "User role",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public UserRole getRole() {
        return role;
    }

    public void setRole(UserRole role) {
        this.role = role;
    }

    @Schema(
            name = "password",
            example = "111fca2d52def4c33f4d8f1be7e74d14b65d365e5ddb91610c3c0dbecc192073b0b0df28213e3828cc0321f6286baf94449a4f8803203be3293595f4d67ff7e2",
            description = "Encrypted user password",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @Schema(
            name = "email",
            example = "485157@muni.cz",
            description = "User email address, must be the same as MUNI email address in format [uco]@muni.cz",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }
}
