package org.delta.dto.entities.user;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.enums.UserRole;
import com.google.gson.Gson;

public class UserDetailDTO extends UserBaseDTO {
    private long userID;
    private String emailAddress;

    public long getUserID() {
        return userID;
    }

    public void setUserID(long userID) {
        this.userID = userID;
    }


    @Schema(
            name = "emailAddress",
            example = "485157@muni.cz",
            description = "User email address",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getEmailAddress() {
        return emailAddress;
    }

    public void setEmailAddress(String emailAddress) {
        this.emailAddress = emailAddress;
    }

    @Override
    public boolean equals(Object o) {
        if (o == this) {
            return true;
        }

        if (!(o instanceof UserDetailDTO)) {
            return false;
        }

        UserDetailDTO user = (UserDetailDTO) o;

        return user.getUserID() == this.userID;
    }

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }
}
