package org.delta.dto.entities.user;

import io.swagger.v3.oas.annotations.media.Schema;
import org.delta.dto.enums.UserRole;

import java.util.Optional;

public class UserSearchParamsDTO {
    private Optional<String> userName;
    private Optional<UserRole> role;
    private Optional<String> firstName;
    private Optional<String> lastName;

    public UserSearchParamsDTO() {

    }

    public UserSearchParamsDTO(Optional<String> userName, Optional<UserRole> role, Optional<String> firstName, Optional<String> lastName) {
        this.userName = userName;
        this.role = role;
        this.firstName = firstName;
        this.lastName = lastName;
    }

    @Schema(
            name = "userName",
            example = "wine_lover22",
            description = "Unique user name",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public Optional<String> getUserName() {
        return userName;
    }

    public void setUserName(Optional<String> userName) {
        this.userName = userName;
    }

    @Schema(
            name = "role",
            example = "MANAGER",
            description = "User role",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public Optional<UserRole> getRole() {
        return role;
    }

    public void setRole(Optional<UserRole> role) {
        this.role = role;
    }

    @Schema(
            name = "firstName",
            example = "John",
            description = "User first name",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public Optional<String> getFirstName() {
        return firstName;
    }

    public void setFirstName(Optional<String> firstName) {
        this.firstName = firstName;
    }

    @Schema(
            name = "lastName",
            example = "Wick",
            description = "User last name",
            requiredMode = Schema.RequiredMode.NOT_REQUIRED
    )
    public Optional<String> getLastName() {
        return lastName;
    }

    public void setLastName(Optional<String> lastName) {
        this.lastName = lastName;
    }
}
