package org.delta.dto.entities.wine;

import io.swagger.v3.oas.annotations.media.Schema;

import java.math.BigDecimal;

public class WineBaseDTO {

    protected String name;
    protected BigDecimal volume;
    protected int year;
    protected String grapeType;


    @Schema(
            name = "name",
            example = "greatWine, 2023",
            description = "Wine name",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getName() { return name; }

    public void setName(String name) {
        this.name = name;
    }

    @Schema(
            name = "volume",
            example = "20",
            description = "Wine volume in liters",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public BigDecimal getVolume() {
        return volume;
    }

    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }


    @Schema(
            name = "year",
            example = "2023",
            description = "Production year",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    @Schema(
            name = "grapeType",
            example = "goodGrapes",
            description = "Type of grape",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getGrapeType() {
        return grapeType;
    }

    public void setGrapeType(String grapeType) {
        this.grapeType = grapeType;
    }
}
