package org.delta.dto.entities.wine;

import com.google.gson.Gson;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.Objects;

public class WineDTO extends WineBaseDTO {


    private String wineState;

    private Long id;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }


    @Schema(
            name = "wineState",
            example = "AGING_WINE",
            description = "State of wine",
            requiredMode = Schema.RequiredMode.REQUIRED
    )
    public String getWineState() {
        return wineState;
    }

    public void setWineState(String wineState) {
        this.wineState = wineState;
    }

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WineDTO wineDTO = (WineDTO) o;
        return wineDTO.volume.compareTo(volume) == 0 && year == wineDTO.year && Objects.equals(name, wineDTO.name) && Objects.equals(grapeType, wineDTO.grapeType) && Objects.equals(wineState, wineDTO.wineState) && Objects.equals(id, wineDTO.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, volume, year, grapeType, wineState);
    }
}