package org.delta.winery.harvestwine.data.initialization;

import jakarta.annotation.PostConstruct;
import org.delta.dto.entities.grape.AddGrapeDTO;
import org.delta.dto.entities.harvest.AddHarvestDTO;
import org.delta.winery.harvestwine.data.mapping.GrapeMapping;
import org.delta.winery.harvestwine.data.model.Grape;
import org.delta.winery.harvestwine.service.HarvestManagementService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;

@Service
@Transactional
public class DataInitialization {

    private final HarvestManagementService harvestService;

    public DataInitialization(HarvestManagementService harvestService) {
        this.harvestService = harvestService;
    }

    @PostConstruct
    public void InitializeData() {
        //Grapes

        AddGrapeDTO addGrape1 = new AddGrapeDTO();
        addGrape1.setGrapeName("Cabernet Sauvignon");
        Grape grape1 = harvestService.addGrape(addGrape1);

        AddGrapeDTO addGrape2 = new AddGrapeDTO();
        addGrape2.setGrapeName("Chardonnay");
        Grape grape2 = harvestService.addGrape(addGrape2);

        AddGrapeDTO addGrape3 = new AddGrapeDTO();
        addGrape3.setGrapeName("Pinot Noir");
        Grape grape3 = harvestService.addGrape(addGrape3);

        AddGrapeDTO addGrape4 = new AddGrapeDTO();
        addGrape4.setGrapeName("Riesling");
        Grape grape4 = harvestService.addGrape(addGrape4);

        AddGrapeDTO addGrape5 = new AddGrapeDTO();
        addGrape5.setGrapeName("Sauvignon Blanc");
        Grape grape5 = harvestService.addGrape(addGrape5);

        AddGrapeDTO addGrape6 = new AddGrapeDTO();
        addGrape6.setGrapeName("Syrah");
        Grape grape6 = harvestService.addGrape(addGrape6);

        AddGrapeDTO addGrape7 = new AddGrapeDTO();
        addGrape7.setGrapeName("Zinfandel");
        Grape grape7 = harvestService.addGrape(addGrape7);

        AddGrapeDTO addGrape8 = new AddGrapeDTO();
        addGrape8.setGrapeName("Malbec");
        Grape grape8 = harvestService.addGrape(addGrape8);

        AddGrapeDTO addGrape9 = new AddGrapeDTO();
        addGrape9.setGrapeName("Grenache");
        Grape grape9 = harvestService.addGrape(addGrape9);

        AddGrapeDTO addGrape10 = new AddGrapeDTO();
        addGrape10.setGrapeName("Sangiovese");
        Grape grape10 = harvestService.addGrape(addGrape10);


        //harvests

        AddHarvestDTO harvest1 = new AddHarvestDTO();
        harvest1.setGrape(GrapeMapping.getGrapeDto(grape1));
        harvest1.setPrice(BigDecimal.valueOf(42.5));
        harvest1.setVolume(BigDecimal.valueOf(1100));
        harvest1.setYear(2023);
        harvestService.addHarvest(harvest1);

        AddHarvestDTO harvest2 = new AddHarvestDTO();
        harvest2.setGrape(GrapeMapping.getGrapeDto(grape2));
        harvest2.setPrice(BigDecimal.valueOf(60.0));
        harvest2.setVolume(BigDecimal.valueOf(3000));
        harvest2.setYear(2023);
        harvestService.addHarvest(harvest2);

        AddHarvestDTO harvest3 = new AddHarvestDTO();
        harvest3.setGrape(GrapeMapping.getGrapeDto(grape3));
        harvest3.setPrice(BigDecimal.valueOf(51.5));
        harvest3.setVolume(BigDecimal.valueOf(1100));
        harvest3.setYear(2023);
        harvestService.addHarvest(harvest3);

        AddHarvestDTO harvest4 = new AddHarvestDTO();
        harvest4.setGrape(GrapeMapping.getGrapeDto(grape4));
        harvest4.setPrice(BigDecimal.valueOf(60.0));
        harvest4.setVolume(BigDecimal.valueOf(1200));
        harvest4.setYear(2023);
        harvestService.addHarvest(harvest4);

        AddHarvestDTO harvest5 = new AddHarvestDTO();
        harvest5.setGrape(GrapeMapping.getGrapeDto(grape5));
        harvest5.setPrice(BigDecimal.valueOf(33.5));
        harvest5.setVolume(BigDecimal.valueOf(3000));
        harvest5.setYear(2023);
        harvestService.addHarvest(harvest5);

        AddHarvestDTO harvest6 = new AddHarvestDTO();
        harvest6.setGrape(GrapeMapping.getGrapeDto(grape6));
        harvest6.setPrice(BigDecimal.valueOf(33.5));
        harvest6.setVolume(BigDecimal.valueOf(2400));
        harvest6.setYear(2023);
        harvestService.addHarvest(harvest6);

        AddHarvestDTO harvest7 = new AddHarvestDTO();
        harvest7.setGrape(GrapeMapping.getGrapeDto(grape7));
        harvest7.setPrice(BigDecimal.valueOf(33.5));
        harvest7.setVolume(BigDecimal.valueOf(500));
        harvest7.setYear(2023);
        harvestService.addHarvest(harvest7);

        AddHarvestDTO harvest8 = new AddHarvestDTO();
        harvest8.setGrape(GrapeMapping.getGrapeDto(grape8));
        harvest8.setPrice(BigDecimal.valueOf(60.0));
        harvest8.setVolume(BigDecimal.valueOf(500));
        harvest8.setYear(2023);
        harvestService.addHarvest(harvest8);

        AddHarvestDTO harvest9 = new AddHarvestDTO();
        harvest9.setGrape(GrapeMapping.getGrapeDto(grape9));
        harvest9.setPrice(BigDecimal.valueOf(33.5));
        harvest9.setVolume(BigDecimal.valueOf(1600));
        harvest9.setYear(2023);
        harvestService.addHarvest(harvest9);

        AddHarvestDTO harvest10 = new AddHarvestDTO();
        harvest10.setGrape(GrapeMapping.getGrapeDto(grape10));
        harvest10.setPrice(BigDecimal.valueOf(51.5));
        harvest10.setVolume(BigDecimal.valueOf(1600));
        harvest10.setYear(2023);
        harvestService.addHarvest(harvest10);
    }
}
