package org.delta.winery.harvestwine.data.model;

import jakarta.persistence.*;
import jakarta.validation.constraints.Size;

import java.util.Objects;
import java.util.Set;

@Entity
@Table(name = "grapes")
public class Grape {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "id")
    private Long id;

    @Size(min = 1)
    @Column(name = "grapeName", length = 50, unique = true, nullable = false)
    private String grapeName;

    @OneToMany(mappedBy = "grape")
    private Set<Harvest> harvests;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getGrapeName() {
        return grapeName;
    }

    public void setGrapeName(String grapeName) {
        this.grapeName = grapeName;
    }

    public Set<Harvest> getHarvests() {
        return harvests;
    }

    public void setHarvests(Set<Harvest> harvests) {
        this.harvests = harvests;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Grape grape)) return false;
        return Objects.equals(getGrapeName(), grape.getGrapeName());
    }
}
