package org.delta.winery.harvestwine.data.model;

import jakarta.persistence.*;
import org.hibernate.validator.constraints.Range;

import java.math.BigDecimal;


@Entity
@Table(name = "harvests")
public class Harvest {


    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "id")
    private Long id;


    @ManyToOne
    @JoinColumn(name = "grape_id", nullable = false)
    private Grape grape;

    @Column(name = "harvest_volume", nullable = false)
    private BigDecimal volume;

    @Column(name = "harvest_price")
    private BigDecimal price;

    @Range(min = 1)
    @Column(name = "harvest_year", nullable = false)
    private int year;

    @Override
    public boolean equals(Object o) {
        if (o == this)
            return true;
        if (!(o instanceof Harvest harvest))
            return false;

        return harvest.getId() == this.id;
    }

    public Long getId() {
        return id;
    }

    public Grape getGrape() {
        return grape;
    }

    public BigDecimal getVolume() {
        return volume;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public int getYear() {
        return year;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public void setGrape(Grape grape) {
        this.grape = grape;
    }

    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public void setYear(int year) {
        this.year = year;
    }


}
    
