package org.delta.winery.harvestwine.data.repository;

import org.delta.winery.harvestwine.data.model.Grape;
import org.delta.winery.harvestwine.data.model.Harvest;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Optional;

public interface GrapeRepository extends JpaRepository<Grape, Long> {

    @Query("select g from Grape g")
    public List<Grape> getGrapes();

    @Query("SELECT g FROM Grape g WHERE g.grapeName = :grapeName")
    Optional<Grape> findGrapeByName(@Param("grapeName") String grapeName);
}
