package org.delta.winery.harvestwine.data.repository;

import org.delta.winery.harvestwine.data.model.Harvest;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Collection;

@Repository
public interface HarvestRepository extends JpaRepository<Harvest, Long> {

    @Query("SELECT h FROM Harvest h WHERE h.grape = :grapeId")
    Collection<Harvest> findByGrape(@Param("grape") Long grapeId);

    @Query("SELECT h FROM Harvest h WHERE h.year = :year")
    Collection<Harvest> findByYear(@Param("year") int year);

    @Query("SELECT h FROM Harvest h WHERE h.year = :year and h.grape=:grapeId")
    Collection<Harvest> findByYearAndGrape(@Param("year") int year, @Param("grape") Long grapeId);


}
