package org.delta.winery.harvestwine.facade;

import org.delta.dto.entities.grape.AddGrapeDTO;
import org.delta.dto.entities.grape.GrapeDTO;
import org.delta.dto.entities.harvest.AddHarvestDTO;
import org.delta.dto.entities.harvest.HarvestListEntityDTO;
import org.delta.dto.entities.harvest.UpdateHarvestDTO;
import org.springframework.http.ResponseEntity;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Optional;

public interface HarvestFacade {
    public ResponseEntity<Collection<HarvestListEntityDTO>> getHarvestsWithParams(Optional<Long> grapeId, Optional<Integer> year);

    public ResponseEntity<HarvestListEntityDTO> addHarvest(AddHarvestDTO harvest);

    public ResponseEntity<HarvestListEntityDTO> updateHarvest(UpdateHarvestDTO harvest);

    public ResponseEntity<HarvestListEntityDTO> getHarvest(Long id);

    public ResponseEntity<HarvestListEntityDTO> deleteHarvest(Long id);

    public ResponseEntity<Collection<GrapeDTO>> getGrapes();

    public ResponseEntity<GrapeDTO> addGrape(AddGrapeDTO grape);

    public ResponseEntity<GrapeDTO> getGrape(String grapeName);

    public ResponseEntity<GrapeDTO> deleteGrape(String grapeName);

    public ResponseEntity<Boolean> canBeStored(BigDecimal volume, String bearer);

    public ResponseEntity<BigDecimal> surplusValue(BigDecimal volumeInLiters, BigDecimal purchasePricePerLiter, BigDecimal bottlePrice, Long id, String bearer);

}
