package org.delta.winery.harvestwine.service;

import org.delta.dto.entities.grape.AddGrapeDTO;
import org.delta.dto.entities.harvest.AddHarvestDTO;
import org.delta.dto.entities.harvest.UpdateHarvestDTO;
import org.delta.winery.harvestwine.data.model.Grape;
import org.delta.winery.harvestwine.data.model.Harvest;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Optional;

public interface HarvestManagementService {

    Collection<Harvest> getHarvestsByGrapeAndYear(Optional<Long> grapeId, Optional<Integer> year);

    Harvest addHarvest(AddHarvestDTO harvest);

    Harvest updateHarvest(UpdateHarvestDTO harvest);

    Harvest getHarvest(Long id);

    Harvest deleteHarvest(Long id);

    Collection<Grape> getGrapes();

    Grape addGrape(AddGrapeDTO grape);

    Grape getGrape(String grapeName);

    Grape deleteGrape(String grapeName);

    boolean canBeStored(BigDecimal volume, String bearer);

    BigDecimal surplusValue(BigDecimal volumeInLiters, BigDecimal purchasePricePerLiter, BigDecimal bottlePrice, Long id, String bearer);


}
