package org.delta.winery.sellwine.data.mapping;

import org.delta.dto.entities.order.AddOrderDTO;
import org.delta.dto.entities.order.OrderDTO;
import org.delta.dto.entities.order.OrderListEntityDTO;
import org.delta.winery.sellwine.data.model.Order;

import java.util.ArrayList;
import java.util.HashSet;

public class OrderMapping {

    public static OrderListEntityDTO getOrderListEntityDto(Order order) {
        OrderListEntityDTO dto = new OrderListEntityDTO();
        dto.setId(order.getId());
        dto.setBottles(new ArrayList<>(order.getBottles().stream().map(BottleMapping::getBottleListEntityDto).toList()));
        dto.setCompleted(order.isCompleted());
        dto.setFeedback(order.getFeedback());
        return dto;
    }

    public static OrderDTO getOrderDto(Order order) {
        OrderDTO dto = new OrderDTO();
        dto.setId(order.getId());
        dto.setBottles(new HashSet<>(order.getBottles().stream().map(BottleMapping::getBottleDto).toList()));
        dto.setCompleted(order.isCompleted());
        dto.setFeedback(order.getFeedback());
        return dto;
    }

    public static Order getOrderEntity(AddOrderDTO orderDTO) {
        Order order = new Order(); //You can only create empty orders
        return order;
    }
}
