package org.delta.winery.sellwine.data.model;

import jakarta.persistence.*;
import org.delta.dto.enums.WineType;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Entity
@Table(name = "orders")
public class Order {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "order_id")
    private Long id;

    @ManyToMany(mappedBy = "orders")
    private Set<Bottle> bottles = new HashSet<>();

    @Column(name = "completed")
    private boolean completed;

    @Column(name = "feedback")
    private String feedback;
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public void addBottle(Bottle bottle) {
        bottles.add(bottle);
        bottle.addOrder(this);
    }

    public void removeBottle(Bottle bottle) {
        bottles.remove(bottle);
        bottle.removeOrder(this);
    }
    public Set<Bottle> getBottles() {
        return bottles;
    }

    public void setBottles(Set<Bottle> bottles) {
        this.bottles = bottles;
    }

    public boolean isCompleted() {
        return completed;
    }

    public void setCompleted(boolean completed) {
        this.completed = completed;
    }

    public String getFeedback() {
        return feedback;
    }

    public void setFeedback(String feedback) {
        this.feedback = feedback;
    }

    @Override
    public boolean equals(Object o) {
        if (o == this)
            return true;
        if (!(o instanceof Order order))
            return false;

        return order.getId() == this.id;
    }
}
