package org.delta.winery.sellwine.data.repository;

import org.delta.winery.sellwine.data.model.Bottle;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface BottleRepository extends JpaRepository<Bottle, Long> {
    @Query("SELECT b FROM Bottle b WHERE (:origin is null OR :origin = b.origin) AND (:year is null OR :year = b.year)")
    List<Bottle> filterBottles(@Param("origin")Optional<String> origin, @Param("year") Optional<Integer> year);
}
