package org.delta.winery.sellwine.service;

import org.delta.dto.entities.bottle.*;
import org.delta.dto.entities.order.*;
import org.delta.dto.entities.purchase.AddPurchaseDTO;
import org.delta.dto.entities.purchase.UpdatePurchaseDTO;
import org.delta.winery.sellwine.data.model.Bottle;
import org.delta.winery.sellwine.data.model.Order;

import java.util.Collection;
import java.util.Optional;

public interface SaleManagementService {
    Collection<Bottle> getBottles();

    Collection<Bottle> getBottles(Optional<String> origin, Optional<Integer> year);

    Collection<Order> getOrders();

    Bottle addBottle(AddBottleDTO bottle);

    Order addOrder(AddOrderDTO order);

    Bottle updateBottle(UpdateBottleDTO bottle);

    Order addBottleToOrder(AddBottleToOrderDTO dto);
    Order removeBottleFromOrder(RemoveBottleFromOrderDTO dto);

    Order completeOrder(OrderBaseDTO orderDTO);
    Order leaveFeedbackOnOrder(UpdateOrderDTO orderDTO);
    Bottle getBottle(Long id);

    Order getOrder(Long id);

    Bottle deleteBottle(Long bottleID);

    Order deleteOrder(Long orderID);
}