package org.delta.Data.Initialization;

import jakarta.annotation.PostConstruct;

import org.delta.dto.entities.bottle.AddBottleDTO;
import org.delta.dto.enums.WineType;
import org.delta.service.StoreWineService;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;

@Service
public class DataInitialization {

    private final StoreWineService storeWineService;



    public DataInitialization(StoreWineService storeWineService) {
        this.storeWineService = storeWineService;
    }

    @PostConstruct
    public void InitializeData() {
        AddBottleDTO bottle1 = new AddBottleDTO();
        bottle1.setPrice(BigDecimal.valueOf(81.5F));
        bottle1.setAmount(84);
        bottle1.setVolume(BigDecimal.valueOf(0.75F));
        bottle1.setYear(2021);
        bottle1.setOrigin("Slovakia");
        bottle1.setName("sweet Merlot");
        bottle1.setWineType(WineType.RED);
        storeWineService.addBottle(bottle1);

        AddBottleDTO bottle2 = new AddBottleDTO();
        bottle2.setPrice(BigDecimal.valueOf(72.5F));
        bottle2.setAmount(301);
        bottle2.setVolume(BigDecimal.valueOf(0.75F));
        bottle2.setYear(2022);
        bottle2.setOrigin("Slovakia");
        bottle2.setName("sweet Grenache");
        bottle2.setWineType(WineType.RED);
        storeWineService.addBottle(bottle2);

        AddBottleDTO bottle3 = new AddBottleDTO();
        bottle3.setPrice(BigDecimal.valueOf(90.0F));
        bottle3.setAmount(5);
        bottle3.setVolume(BigDecimal.valueOf(0.75F));
        bottle3.setYear(2023);
        bottle3.setOrigin("Czechia");
        bottle3.setName("quality Merlot");
        bottle3.setWineType(WineType.RED);
        storeWineService.addBottle(bottle3);

        AddBottleDTO bottle4 = new AddBottleDTO();
        bottle4.setPrice(BigDecimal.valueOf(70.0F));
        bottle4.setAmount(5);
        bottle4.setVolume(BigDecimal.valueOf(0.75F));
        bottle4.setYear(2021);
        bottle4.setOrigin("Moldova");
        bottle4.setName("quality Riesling");
        bottle4.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle4);

        AddBottleDTO bottle5 = new AddBottleDTO();
        bottle5.setPrice(BigDecimal.valueOf(63.5F));
        bottle5.setAmount(84);
        bottle5.setVolume(BigDecimal.valueOf(0.75F));
        bottle5.setYear(2022);
        bottle5.setOrigin("France");
        bottle5.setName("quality Cabernet Sauvignon");
        bottle5.setWineType(WineType.RED);
        storeWineService.addBottle(bottle5);

        AddBottleDTO bottle6 = new AddBottleDTO();
        bottle6.setPrice(BigDecimal.valueOf(90.0F));
        bottle6.setAmount(301);
        bottle6.setVolume(BigDecimal.valueOf(0.75F));
        bottle6.setYear(2023);
        bottle6.setOrigin("Moldova");
        bottle6.setName("early Pinot Noir");
        bottle6.setWineType(WineType.RED);
        storeWineService.addBottle(bottle6);

        AddBottleDTO bottle7 = new AddBottleDTO();
        bottle7.setPrice(BigDecimal.valueOf(72.5F));
        bottle7.setAmount(5);
        bottle7.setVolume(BigDecimal.valueOf(0.75F));
        bottle7.setYear(2021);
        bottle7.setOrigin("Czechia");
        bottle7.setName("early Chardonnay");
        bottle7.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle7);

        AddBottleDTO bottle8 = new AddBottleDTO();
        bottle8.setPrice(BigDecimal.valueOf(90.0F));
        bottle8.setAmount(84);
        bottle8.setVolume(BigDecimal.valueOf(0.75F));
        bottle8.setYear(2022);
        bottle8.setOrigin("France");
        bottle8.setName("quality Grenache");
        bottle8.setWineType(WineType.RED);
        storeWineService.addBottle(bottle8);

        AddBottleDTO bottle9 = new AddBottleDTO();
        bottle9.setPrice(BigDecimal.valueOf(63.5F));
        bottle9.setAmount(42);
        bottle9.setVolume(BigDecimal.valueOf(0.75F));
        bottle9.setYear(2023);
        bottle9.setOrigin("Moldova");
        bottle9.setName("quality Pinot Noir");
        bottle9.setWineType(WineType.RED);
        storeWineService.addBottle(bottle9);

        AddBottleDTO bottle10 = new AddBottleDTO();
        bottle10.setPrice(BigDecimal.valueOf(72.5F));
        bottle10.setAmount(5);
        bottle10.setVolume(BigDecimal.valueOf(0.75F));
        bottle10.setYear(2021);
        bottle10.setOrigin("France");
        bottle10.setName("early Cabernet Sauvignon");
        bottle10.setWineType(WineType.RED);
        storeWineService.addBottle(bottle10);

        AddBottleDTO bottle11 = new AddBottleDTO();
        bottle11.setPrice(BigDecimal.valueOf(90.0F));
        bottle11.setAmount(42);
        bottle11.setVolume(BigDecimal.valueOf(0.75F));
        bottle11.setYear(2022);
        bottle11.setOrigin("Moldova");
        bottle11.setName("late Malbec");
        bottle11.setWineType(WineType.RED);
        storeWineService.addBottle(bottle11);

        AddBottleDTO bottle12 = new AddBottleDTO();
        bottle12.setPrice(BigDecimal.valueOf(70.0F));
        bottle12.setAmount(42);
        bottle12.setVolume(BigDecimal.valueOf(0.75F));
        bottle12.setYear(2023);
        bottle12.setOrigin("Slovakia");
        bottle12.setName("late Sangiovese");
        bottle12.setWineType(WineType.RED);
        storeWineService.addBottle(bottle12);

        AddBottleDTO bottle13 = new AddBottleDTO();
        bottle13.setPrice(BigDecimal.valueOf(60F));
        bottle13.setAmount(84);
        bottle13.setVolume(BigDecimal.valueOf(0.75F));
        bottle13.setYear(2021);
        bottle13.setOrigin("France");
        bottle13.setName("early Zinfandel");
        bottle13.setWineType(WineType.RED);
        storeWineService.addBottle(bottle13);

        AddBottleDTO bottle14 = new AddBottleDTO();
        bottle14.setPrice(BigDecimal.valueOf(63.5F));
        bottle14.setAmount(42);
        bottle14.setVolume(BigDecimal.valueOf(0.75F));
        bottle14.setYear(2022);
        bottle14.setOrigin("Slovakia");
        bottle14.setName("quality Chardonnay");
        bottle14.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle14);

        AddBottleDTO bottle15 = new AddBottleDTO();
        bottle15.setPrice(BigDecimal.valueOf(63.5F));
        bottle15.setAmount(42);
        bottle15.setVolume(BigDecimal.valueOf(0.75F));
        bottle15.setYear(2023);
        bottle15.setOrigin("France");
        bottle15.setName("early Malbec");
        bottle15.setWineType(WineType.RED);
        storeWineService.addBottle(bottle15);

        AddBottleDTO bottle16 = new AddBottleDTO();
        bottle16.setPrice(BigDecimal.valueOf(70.0F));
        bottle16.setAmount(301);
        bottle16.setVolume(BigDecimal.valueOf(0.75F));
        bottle16.setYear(2021);
        bottle16.setOrigin("France");
        bottle16.setName("quality Riesling");
        bottle16.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle16);

        AddBottleDTO bottle17 = new AddBottleDTO();
        bottle17.setPrice(BigDecimal.valueOf(63.5F));
        bottle17.setAmount(420);
        bottle17.setVolume(BigDecimal.valueOf(0.75F));
        bottle17.setYear(2022);
        bottle17.setOrigin("Moldova");
        bottle17.setName("sweet Grenache");
        bottle17.setWineType(WineType.RED);
        storeWineService.addBottle(bottle17);

        AddBottleDTO bottle18 = new AddBottleDTO();
        bottle18.setPrice(BigDecimal.valueOf(60F));
        bottle18.setAmount(301);
        bottle18.setVolume(BigDecimal.valueOf(0.75F));
        bottle18.setYear(2023);
        bottle18.setOrigin("Slovakia");
        bottle18.setName("sweet Chardonnay");
        bottle18.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle18);

        AddBottleDTO bottle19 = new AddBottleDTO();
        bottle19.setPrice(BigDecimal.valueOf(60F));
        bottle19.setAmount(69);
        bottle19.setVolume(BigDecimal.valueOf(0.75F));
        bottle19.setYear(2021);
        bottle19.setOrigin("France");
        bottle19.setName("quality Malbec");
        bottle19.setWineType(WineType.RED);
        storeWineService.addBottle(bottle19);

        AddBottleDTO bottle20 = new AddBottleDTO();
        bottle20.setPrice(BigDecimal.valueOf(63.5F));
        bottle20.setAmount(5);
        bottle20.setVolume(BigDecimal.valueOf(0.75F));
        bottle20.setYear(2022);
        bottle20.setOrigin("Slovakia");
        bottle20.setName("quality Sauvignon Blanc");
        bottle20.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle20);

        AddBottleDTO bottle21 = new AddBottleDTO();
        bottle21.setPrice(BigDecimal.valueOf(70.0F));
        bottle21.setAmount(301);
        bottle21.setVolume(BigDecimal.valueOf(0.75F));
        bottle21.setYear(2023);
        bottle21.setOrigin("Czechia");
        bottle21.setName("early Pinot Noir");
        bottle21.setWineType(WineType.RED);
        storeWineService.addBottle(bottle21);

        AddBottleDTO bottle22 = new AddBottleDTO();
        bottle22.setPrice(BigDecimal.valueOf(60F));
        bottle22.setAmount(42);
        bottle22.setVolume(BigDecimal.valueOf(0.75F));
        bottle22.setYear(2021);
        bottle22.setOrigin("France");
        bottle22.setName("quality Syrah");
        bottle22.setWineType(WineType.RED);
        storeWineService.addBottle(bottle22);

        AddBottleDTO bottle23 = new AddBottleDTO();
        bottle23.setPrice(BigDecimal.valueOf(90.0F));
        bottle23.setAmount(301);
        bottle23.setVolume(BigDecimal.valueOf(0.75F));
        bottle23.setYear(2022);
        bottle23.setOrigin("Czechia");
        bottle23.setName("quality Merlot");
        bottle23.setWineType(WineType.RED);
        storeWineService.addBottle(bottle23);

        AddBottleDTO bottle24 = new AddBottleDTO();
        bottle24.setPrice(BigDecimal.valueOf(90.0F));
        bottle24.setAmount(69);
        bottle24.setVolume(BigDecimal.valueOf(0.75F));
        bottle24.setYear(2023);
        bottle24.setOrigin("Slovakia");
        bottle24.setName("late Syrah");
        bottle24.setWineType(WineType.RED);
        storeWineService.addBottle(bottle24);

        AddBottleDTO bottle25 = new AddBottleDTO();
        bottle25.setPrice(BigDecimal.valueOf(70.0F));
        bottle25.setAmount(301);
        bottle25.setVolume(BigDecimal.valueOf(0.75F));
        bottle25.setYear(2021);
        bottle25.setOrigin("France");
        bottle25.setName("sweet Cabernet Sauvignon");
        bottle25.setWineType(WineType.RED);
        storeWineService.addBottle(bottle25);

        AddBottleDTO bottle26 = new AddBottleDTO();
        bottle26.setPrice(BigDecimal.valueOf(63.5F));
        bottle26.setAmount(5);
        bottle26.setVolume(BigDecimal.valueOf(0.75F));
        bottle26.setYear(2022);
        bottle26.setOrigin("Slovakia");
        bottle26.setName("sweet Malbec");
        bottle26.setWineType(WineType.RED);
        storeWineService.addBottle(bottle26);

        AddBottleDTO bottle27 = new AddBottleDTO();
        bottle27.setPrice(BigDecimal.valueOf(90.0F));
        bottle27.setAmount(69);
        bottle27.setVolume(BigDecimal.valueOf(0.75F));
        bottle27.setYear(2023);
        bottle27.setOrigin("Slovakia");
        bottle27.setName("late Cabernet Sauvignon");
        bottle27.setWineType(WineType.RED);
        storeWineService.addBottle(bottle27);

        AddBottleDTO bottle28 = new AddBottleDTO();
        bottle28.setPrice(BigDecimal.valueOf(81.5F));
        bottle28.setAmount(84);
        bottle28.setVolume(BigDecimal.valueOf(0.75F));
        bottle28.setYear(2021);
        bottle28.setOrigin("Czechia");
        bottle28.setName("early Cabernet Sauvignon");
        bottle28.setWineType(WineType.RED);
        storeWineService.addBottle(bottle28);

        AddBottleDTO bottle29 = new AddBottleDTO();
        bottle29.setPrice(BigDecimal.valueOf(72.5F));
        bottle29.setAmount(75);
        bottle29.setVolume(BigDecimal.valueOf(0.75F));
        bottle29.setYear(2022);
        bottle29.setOrigin("Slovakia");
        bottle29.setName("quality Merlot");
        bottle29.setWineType(WineType.RED);
        storeWineService.addBottle(bottle29);

        AddBottleDTO bottle30 = new AddBottleDTO();
        bottle30.setPrice(BigDecimal.valueOf(60F));
        bottle30.setAmount(5);
        bottle30.setVolume(BigDecimal.valueOf(0.75F));
        bottle30.setYear(2023);
        bottle30.setOrigin("Slovakia");
        bottle30.setName("early Sauvignon Blanc");
        bottle30.setWineType(WineType.WHITE);
        storeWineService.addBottle(bottle30);
    }

}
