package org.delta.storewine.tests;

import org.delta.Data.Model.Bottle;
import org.delta.dto.entities.bottle.AddBottleDTO;
import org.delta.dto.entities.bottle.BottleListEntityDTO;
import org.delta.dto.enums.WineType;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.MockMvc;
import com.fasterxml.jackson.databind.ObjectMapper;

import static org.junit.jupiter.api.Assertions.assertTrue;
import static org.springframework.http.RequestEntity.post;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@SpringBootTest
@AutoConfigureMockMvc
public class StoreWineTestController {
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private MockMvc mockMvc;

    @Test
    void checkEndpoints() throws Exception {
        mockMvc.perform(get("/store/bottles"))
                .andExpect(status().isOk());
    }

   @Test
    void getBottles() throws Exception {
        String result = mockMvc.perform(get("/store/bottles"))
                .andExpect(status().isOk())
                .andReturn()
                .getResponse()
                .getContentAsString();
        BottleListEntityDTO[] listEntity = objectMapper.readValue(result, BottleListEntityDTO[].class);

        assertTrue(listEntity.length != 0);
    }
}
