package org.delta.winery.usermanagement.data.initialization;

import jakarta.annotation.PostConstruct;
import org.delta.dto.entities.user.AddUserDTO;
import org.delta.dto.enums.UserRole;
import org.delta.winery.usermanagement.service.UserManagementService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class DataInitialization {

    private final UserManagementService userService;

    public DataInitialization(UserManagementService userService) {
        this.userService = userService;
    }

    @PostConstruct
    public void InitializeData() {
        AddUserDTO user = new AddUserDTO();
        user.setFirstName("Martin");
        user.setLastName("Kyjac");
        user.setRole(UserRole.MANAGER);
        user.setEmail("485157@muni.cz");
        user.setPassword("058de982c06e72b8510ae4415f07869875d44de307e253b1eec9d95df4eea7f0af978d67dc077b8b573a1e4e12b94c8d3332d602111f0ec15bf3a80da606dc34");
        user.setUserName("sigma_male");
        userService.addUser(user);

        user.setFirstName("Martin");
        user.setLastName("Hesko");
        user.setRole(UserRole.BUYER);
        user.setEmail("484964@muni.cz");
        user.setPassword("6e7a8b1d98f0c23e6a40d9e7c41f6853eefb7f4e8c77ab649e2f6aebda88dd4ec2162dc2a5a9b93d750fd066efdb6313fdcafd57a7b7b1a5a6328c2755b670c1");
        user.setUserName("484964");
        userService.addUser(user);

        user.setFirstName("Laura");
        user.setLastName("Ondušková");
        user.setRole(UserRole.BUYER);
        user.setEmail("484093@muni.cz");
        user.setPassword("d54b3a9f81091bce32fe6f54c14b6d0f3473d10c8b4f91da4d34e80b72b7398402c27e37a7d58c3f68cc869aa83b6c48a6710d5f21aef7d67d5e2e8d446b8e7f");
        user.setUserName("485157");
        userService.addUser(user);

        user.setFirstName("Vojtěch");
        user.setLastName("Peschel");
        user.setRole(UserRole.BUYER);
        user.setPassword("ad309e952de6103cf33933bf92a3b75da6a7490ea24f4ecf11e76d49730d88641cb374eefb1f4c52a1d5130a2a8f9a90917301998689bd39f4cf15b2b9266fcc");
        user.setUserName("12345");
        user.setEmail("492796@muni.cz");
        user.setPassword("b106ac5a95a0f77e9d41e0ae7d4f5c82b06e073146a8c2b6c6b1f6b1d8ef82487c69c8018b021c9ef5dcf5bdc2b15673a5e9e811b4888d42f98e6f243cf7190e");
        userService.addUser(user);

        user.setFirstName("Martin");
        user.setLastName("Pernica");
        user.setRole(UserRole.BUYER);
        user.setEmail("492978@muni.cz");
        user.setPassword("ed4a719c53a6d7c8f6b23f908d2dcbe7456a6bc76c678e49e8b4a5a68910f3624e8f2d4eb84b4a0e417c9717a25c1f2e8a7b392f7e7686a5c9a1bf032bf0c14b");
        user.setUserName("492978");
        userService.addUser(user);
    }
}
