package org.delta.winery.usermanagement.test.controller;


import com.fasterxml.jackson.databind.ObjectMapper;
import org.delta.dto.entities.user.AddUserDTO;
import org.delta.dto.entities.user.UserListEntityDTO;
import org.delta.dto.enums.UserRole;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.MockMvc;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@SpringBootTest
@AutoConfigureMockMvc
@Disabled
public class UserControllerTests {
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private MockMvc mockMvc;

    @Test
    void getUsers() throws Exception {
        String result = mockMvc.perform(get("/users"))
                .andExpect(status().isOk())
                .andReturn()
                .getResponse()
                .getContentAsString();
        UserListEntityDTO[] listEntity = objectMapper.readValue(result, UserListEntityDTO[].class);

        Assertions.assertTrue(listEntity.length != 0);
    }

    @Test
    void addUser() throws Exception {

        AddUserDTO addUser= new AddUserDTO();
        addUser.setEmail("email");
        addUser.setUserName("username");
        addUser.setFirstName("firstname");
        addUser.setRole(UserRole.MANAGER);
        addUser.setLastName("lastname");
        addUser.setMiddleName("middlename");
        addUser.setPassword("password");

        String result = mockMvc.perform(post("/users")
                        .contentType(MediaType.APPLICATION_JSON)
                        .content(asJsonString(addUser)))
                .andExpect(status().isCreated())
                .andReturn()
                .getResponse()
                .getContentAsString();

        UserListEntityDTO userAdded = objectMapper.readValue(result, UserListEntityDTO.class);

        Assertions.assertEquals(userAdded.getUserName(), "username");
        Assertions.assertEquals(userAdded.getUserName(),"username");
        Assertions.assertEquals(userAdded.getFirstName(),"firstname");
        Assertions.assertEquals(userAdded.getRole(),UserRole.MANAGER);
        Assertions.assertEquals(userAdded.getLastName(),"lastname");
        Assertions.assertEquals(userAdded.getMiddleName(),"middlename");

    }

    private String asJsonString(final Object obj) {
        try {
            return new ObjectMapper().writeValueAsString(obj);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}

