package org.delta.winery.wineproduction.data.initialization;


import jakarta.annotation.PostConstruct;
import org.delta.dto.entities.container.AddContainerDTO;
import org.delta.dto.entities.wine.AddWineDTO;
import org.delta.dto.enums.WineState;
import org.delta.winery.wineproduction.data.model.WineContainer;
import org.delta.winery.wineproduction.service.WineProductionService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Iterator;
import java.util.Optional;

@Service
@Transactional
public class DataInitialization {

    private final WineProductionService productionService;

    public DataInitialization(WineProductionService productionService) {
        this.productionService = productionService;
    }

    @PostConstruct
    public void InitializeData() {
        for (int i = 0; i < 65; i++) {
            addContainer();
        }
        Iterator<WineContainer> containers= productionService.getWineContainers(Optional.of(true), Optional.of(BigDecimal.valueOf(1000F))).iterator();

        AddWineDTO wine1 = new AddWineDTO();
        wine1.setName("Merlot");
        wine1.setWineState(String.valueOf(WineState.AGING_WINE));
        wine1.setYear(2023);
        wine1.setVolume(BigDecimal.valueOf(1000));
        wine1.setGrapeType("Merlot");
        productionService.addWine(wine1, containers.next());

        AddWineDTO wine2 = new AddWineDTO();
        wine2.setName("Merlot");
        wine2.setWineState(String.valueOf(WineState.AGING_WINE));
        wine2.setYear(2023);
        wine2.setVolume(BigDecimal.valueOf(100));
        wine2.setGrapeType("Merlot");
        productionService.addWine(wine2, containers.next());

        AddWineDTO wine3 = new AddWineDTO();
        wine3.setName("Cabernet Sauvignon");
        wine3.setWineState(String.valueOf(WineState.AGING_WINE));
        wine3.setYear(2023);
        wine3.setVolume(BigDecimal.valueOf(1000));
        wine3.setGrapeType("Cabernet Sauvignon");
        productionService.addWine(wine3, containers.next());

        AddWineDTO wine4 = new AddWineDTO();
        wine4.setName("Cabernet Sauvignon");
        wine4.setWineState(String.valueOf(WineState.AGING_WINE));
        wine4.setYear(2023);
        wine4.setVolume(BigDecimal.valueOf(1000));
        wine4.setGrapeType("Cabernet Sauvignon");
        productionService.addWine(wine4, containers.next());

        AddWineDTO wine5 = new AddWineDTO();
        wine5.setName("Cabernet Sauvignon");
        wine5.setWineState(String.valueOf(WineState.AGING_WINE));
        wine5.setYear(2023);
        wine5.setVolume(BigDecimal.valueOf(1000));
        wine5.setGrapeType("Cabernet Sauvignon");
        productionService.addWine(wine5, containers.next());

        AddWineDTO wine6 = new AddWineDTO();
        wine6.setName("Chardonnay");
        wine6.setWineState(String.valueOf(WineState.AGING_WINE));
        wine6.setYear(2023);
        wine6.setVolume(BigDecimal.valueOf(1000));
        wine6.setGrapeType("Chardonnay");
        productionService.addWine(wine6, containers.next());

        AddWineDTO wine7 = new AddWineDTO();
        wine7.setName("Chardonnay");
        wine7.setWineState(String.valueOf(WineState.AGING_WINE));
        wine7.setYear(2023);
        wine7.setVolume(BigDecimal.valueOf(100));
        wine7.setGrapeType("Chardonnay");
        productionService.addWine(wine7, containers.next());

        AddWineDTO wine8 = new AddWineDTO();
        wine8.setName("Pinot Noir");
        wine8.setWineState(String.valueOf(WineState.AGING_WINE));
        wine8.setYear(2023);
        wine8.setVolume(BigDecimal.valueOf(1000));
        wine8.setGrapeType("Pinot Noir");
        productionService.addWine(wine8, containers.next());

        AddWineDTO wine9 = new AddWineDTO();
        wine9.setName("Pinot Noir");
        wine9.setWineState(String.valueOf(WineState.AGING_WINE));
        wine9.setYear(2023);
        wine9.setVolume(BigDecimal.valueOf(200));
        wine9.setGrapeType("Pinot Noir");
        productionService.addWine(wine9, containers.next());

        AddWineDTO wine10 = new AddWineDTO();
        wine10.setName("Riesling");
        wine10.setWineState(String.valueOf(WineState.AGING_WINE));
        wine10.setYear(2023);
        wine10.setVolume(BigDecimal.valueOf(1000));
        wine10.setGrapeType("Riesling");
        productionService.addWine(wine10, containers.next());

        AddWineDTO wine11 = new AddWineDTO();
        wine11.setName("Riesling");
        wine11.setWineState(String.valueOf(WineState.AGING_WINE));
        wine11.setYear(2023);
        wine11.setVolume(BigDecimal.valueOf(1000));
        wine11.setGrapeType("Riesling");
        productionService.addWine(wine11, containers.next());

        AddWineDTO wine12 = new AddWineDTO();
        wine12.setName("Riesling");
        wine12.setWineState(String.valueOf(WineState.AGING_WINE));
        wine12.setYear(2023);
        wine12.setVolume(BigDecimal.valueOf(1000));
        wine12.setGrapeType("Riesling");
        productionService.addWine(wine12, containers.next());

        AddWineDTO wine13 = new AddWineDTO();
        wine13.setName("Sauvignon Blanc");
        wine13.setWineState(String.valueOf(WineState.AGING_WINE));
        wine13.setYear(2023);
        wine13.setVolume(BigDecimal.valueOf(1000));
        wine13.setGrapeType("Sauvignon Blanc");
        productionService.addWine(wine13, containers.next());

        AddWineDTO wine14 = new AddWineDTO();
        wine14.setName("Sauvignon Blanc");
        wine14.setWineState(String.valueOf(WineState.AGING_WINE));
        wine14.setYear(2023);
        wine14.setVolume(BigDecimal.valueOf(1000));
        wine14.setGrapeType("Sauvignon Blanc");
        productionService.addWine(wine14, containers.next());

        AddWineDTO wine15 = new AddWineDTO();
        wine15.setName("Sauvignon Blanc");
        wine15.setWineState(String.valueOf(WineState.AGING_WINE));
        wine15.setYear(2023);
        wine15.setVolume(BigDecimal.valueOf(400));
        wine15.setGrapeType("Sauvignon Blanc");
        productionService.addWine(wine15, containers.next());

        AddWineDTO wine16 = new AddWineDTO();
        wine16.setName("Syrah");
        wine16.setWineState(String.valueOf(WineState.AGING_WINE));
        wine16.setYear(2023);
        wine16.setVolume(BigDecimal.valueOf(500));
        wine16.setGrapeType("Syrah");
        productionService.addWine(wine16, containers.next());

        AddWineDTO wine17 = new AddWineDTO();
        wine17.setName("Zinfandel");
        wine17.setWineState(String.valueOf(WineState.AGING_WINE));
        wine17.setYear(2023);
        wine17.setVolume(BigDecimal.valueOf(500));
        wine17.setGrapeType("Zinfandel");
        productionService.addWine(wine17, containers.next());

        AddWineDTO wine18 = new AddWineDTO();
        wine18.setName("Malbec");
        wine18.setWineState(String.valueOf(WineState.AGING_WINE));
        wine18.setYear(2023);
        wine18.setVolume(BigDecimal.valueOf(1000));
        wine18.setGrapeType("Malbec");
        productionService.addWine(wine18, containers.next());

        AddWineDTO wine19 = new AddWineDTO();
        wine19.setName("Malbec");
        wine19.setWineState(String.valueOf(WineState.AGING_WINE));
        wine19.setYear(2023);
        wine19.setVolume(BigDecimal.valueOf(600));
        wine19.setGrapeType("Malbec");
        productionService.addWine(wine19, containers.next());

        AddWineDTO wine20 = new AddWineDTO();
        wine20.setName("Grenache");
        wine20.setWineState(String.valueOf(WineState.AGING_WINE));
        wine20.setYear(2023);
        wine20.setVolume(BigDecimal.valueOf(1000));
        wine20.setGrapeType("Grenache");
        productionService.addWine(wine20, containers.next());

        AddWineDTO wine21 = new AddWineDTO();
        wine21.setName("Grenache");
        wine21.setWineState(String.valueOf(WineState.AGING_WINE));
        wine21.setYear(2023);
        wine21.setVolume(BigDecimal.valueOf(600));
        wine21.setGrapeType("Grenache");
        productionService.addWine(wine21, containers.next());
    }

    private void addContainer(){
        AddContainerDTO container = new AddContainerDTO();
        container.setEmpty(true);
        container.setCapacity(BigDecimal.valueOf(1000));
        productionService.addContainer(container);
    }
}
