package org.delta.winery.wineproduction.data.mapping;

import org.delta.dto.entities.container.AddContainerDTO;
import org.delta.dto.entities.container.ContainerDTO;
import org.delta.dto.entities.container.ContainerListEntityDTO;
import org.delta.dto.entities.wine.AddWineDTO;
import org.delta.dto.entities.wine.WineDTO;
import org.delta.dto.entities.wine.WineListEntityDTO;
import org.delta.dto.enums.WineState;
import org.delta.winery.wineproduction.data.model.WineContainer;
import org.delta.winery.wineproduction.data.model.Wine;

public class ProductionMapping {

    public static WineListEntityDTO getWineListEntityDto(Wine wine) {
        WineListEntityDTO dto = new WineListEntityDTO();
        dto.setName(wine.getName());
        dto.setWineState(wine.getWineState());
        dto.setGrapeType(wine.getGrapeType());
        dto.setVolume(wine.getVolume());
        dto.setYear(wine.getYear());

        return dto;
    }

    public static WineDTO getWineDto(Wine wine) {
        WineDTO dto = new WineDTO();
        dto.setId(wine.getId());
        dto.setName(wine.getName());
        dto.setWineState(String.valueOf(wine.getWineState()));
        dto.setGrapeType(wine.getGrapeType());
        dto.setVolume(wine.getVolume());
        dto.setYear(wine.getYear());

        return dto;
    }

    public static Wine getWineEntity(AddWineDTO wine) {
        Wine w = new Wine();
        w.setName(wine.getName());
        w.setVolume(wine.getVolume());
        w.setYear(wine.getYear());
        w.setWineState(WineState.valueOf(wine.getWineState()));
        w.setGrapeType(wine.getGrapeType());

        return w;
    }

    public static ContainerListEntityDTO getContainerListEntityDto(WineContainer container) {
        ContainerListEntityDTO dto = new ContainerListEntityDTO();
        dto.setCapacity(container.getCapacity());
        dto.setEmpty(container.getEmpty());

        return dto;
    }

    public static ContainerDTO getContainerDto(WineContainer container) {
        ContainerDTO dto = new ContainerDTO();
        dto.setId(container.getId());
        dto.setCapacity(container.getCapacity());
        dto.setEmpty(container.getEmpty());

        return dto;
    }

    public static WineContainer getContainerEntity(AddContainerDTO container) {
        WineContainer c = new WineContainer();
        c.setCapacity(container.getCapacity());
        c.setEmpty(container.getEmpty());

        return c;
    }


}
