package org.delta.winery.wineproduction.data.model;


import jakarta.persistence.*;
import jakarta.validation.constraints.Size;
import org.delta.dto.enums.WineState;

import java.math.BigDecimal;

@Entity
@Table(name = "stored_wines")
public class Wine {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "id")
    private Long id;
    @Size(min = 1)
    @Column(name = "wine_name", length = 50, nullable = false)
    private String wineName;
    @Column(name = "wine_state", nullable = false)
    private WineState wineState;
    @Column(name = "volume", nullable = false)
    private BigDecimal volume;
    @Column(name = "harvest_year", nullable = false)
    private int year;
    @Size(min = 1)
    @Column(name = "grape_type", nullable = false)
    private String grapeType;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return wineName;
    }

    public void setName(String wineName) {
        this.wineName = wineName;
    }

    public WineState getWineState() {
        return wineState;
    }

    public void setWineState(WineState wineState) {
        this.wineState = wineState;
    }

    public BigDecimal getVolume() {
        return volume;
    }

    public void setVolume(BigDecimal volume) {
        this.volume = volume;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    public String getGrapeType() {
        return grapeType;
    }

    public void setGrapeType(String grapeType) {
        this.grapeType = grapeType;
    }

    public boolean equals(Object o) {
        if (o == this)
            return true;
        if (!(o instanceof Wine wine))
            return false;

        return wine.getId() == this.id;
    }

}
