package org.delta.winery.wineproduction.data.repository;

import org.delta.winery.wineproduction.data.model.WineContainer;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.List;
import java.util.Optional;

@Repository
public interface ContainerRepository extends JpaRepository<WineContainer, Long> {

    @Query("SELECT c FROM WineContainer c WHERE :id = c.id")
    Optional<WineContainer> findContainerById(@Param("id") Long id);

    @Query("SELECT c FROM WineContainer c WHERE (:isEmpty is null OR :isEmpty = c.isEmpty) AND (:capacity is null OR :capacity >= c.capacity)")
    List<WineContainer> filterContainers(@Param("isEmpty") Optional<Boolean> isEmpty, @Param("capacity") Optional<BigDecimal> capacity);

}
