package org.delta.winery.wineproduction.data.repository;

import org.delta.dto.enums.WineState;
import org.delta.winery.wineproduction.data.model.Wine;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.awt.*;
import java.util.List;
import java.util.Optional;
import java.util.OptionalInt;

@Repository
public interface ProductionRepository extends JpaRepository<Wine, Long> {

    @Query("SELECT w FROM Wine w WHERE (:name is null OR :name = w.wineName) AND (:state is null OR :state = w.wineState) AND (:year is null OR :year = w.year) AND (:grapeType is null OR :grapeType = w.grapeType)")
    List<Wine> filterWine(@Param("name") Optional<String> name, @Param("state") Optional<WineState> state, @Param("year") OptionalInt year, @Param("grapeType") Optional<String> grapeType);

    @Query("SELECT w FROM Wine w WHERE :state = w.wineState")
    List<Wine> findWineByState(WineState state);

    @Query("SELECT w FROM Wine w WHERE :id = w.id")
    Optional<Wine> findById(@Param("id") Long id);

}
